package dev.jansel.aglaea.extensions

import dev.jansel.aglaea.botRef
import dev.jansel.aglaea.database.collections.ConfigCollection
import dev.jansel.aglaea.database.entities.ConfigData
import dev.jansel.aglaea.i18n.Translations
import dev.jansel.aglaea.logger
import dev.kord.common.entity.Permission
import dev.kord.common.entity.Snowflake
import dev.kord.core.behavior.channel.createMessage
import dev.kord.core.behavior.getChannelOf
import dev.kord.core.entity.channel.GuildMessageChannel
import dev.kordex.core.checks.hasPermission
import dev.kordex.core.extensions.Extension
import dev.kordex.core.extensions.ephemeralSlashCommand

class SessionExtension : Extension() {
	override val name = "Session"
	override suspend fun setup() {
		logger.info { "ReplaySession extension loaded!" }
		ephemeralSlashCommand {
			check {
				hasPermission(Permission.Administrator)
			}
			name = Translations.Commands.Replaysession.name
			description = Translations.Commands.Replaysession.description
			action {
				val channel = botRef!!.kordRef.getGuildOrNull(Snowflake(1130932838200512584))!!
					.getChannelOf<GuildMessageChannel>(Snowflake(1130954956892029060))
				val toggle = ConfigCollection().get()?.replaySession ?: false
				if (toggle) {
					ConfigCollection().update(ConfigCollection().get()!!.copy(replaySession = false))
					channel.createMessage {
						content = "Replay session disabled by: ${event.interaction.user.globalName}"
					}
					respond {
						content = "Replay session disabled"
					}
				} else {
					if (ConfigCollection().get() == null) {
						ConfigCollection().set(ConfigData(true))
					} else {
						ConfigCollection().update(ConfigCollection().get()!!.copy(replaySession = true))
					}
					channel.createMessage {
						content = "<@&1361987241609527308> Replay session enabled by: ${event.interaction.user.globalName}. SEND UR REPLAYS FOR FREE!"
					}
					respond {
						content = "Replay session enabled"
					}
				}
			}
		}
	}
}
